// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: list_services.sql

package queries

import (
	"context"

	"github.com/gofrs/uuid"
	"github.com/jackc/pgx/v5/pgtype"
)

const listServices = `-- name: ListServices :many

SELECT
    gp.service_name,
    gp.service_peer_id,
    gp.service_protocol,
    gp.delegator_peer_id,
    gp.delegator_name,
    p.name as peer_name,
    p.manager_address,
    cc.iv
FROM
    (
        SELECT
            service_name,
            service_peer_id,
            service_protocol,
            content_hash,
            '' as delegator_peer_id,
            '' as delegator_name
        FROM
            contracts.grants_service_publication
        UNION
        SELECT
            service_name,
            service_peer_id,
            service_protocol,
            content_hash,
            delegator_peer_id as delegator_peer_id,
            dp.name as delegator_name
        FROM
            contracts.grants_delegated_service_publication
                join
            peers.peers dp on (grants_delegated_service_publication.delegator_peer_id = dp.id)
    ) as gp
        JOIN
    contracts.valid_contracts as cvc on (cvc.hash = gp.content_hash)
        JOIN
    peers.peers as p on (p.id = gp.service_peer_id)
        JOIN
    contracts.content cc on (cc.hash = gp.content_hash)
WHERE
                $2::text = ''
            OR
                ($3::text = 'asc' AND cc.iv > $2::uuid)
            OR
                ($3::text = 'desc' AND cc.iv < $2::uuid)

ORDER BY
    CASE
        WHEN $3::text = 'asc' THEN cc.iv END ASC,
    CASE
        WHEN $3::text = 'desc' THEN cc.iv END DESC
LIMIT $1
`

type ListServicesParams struct {
	Limit             int32
	PaginationStartID string
	OrderDirection    string
}

type ListServicesRow struct {
	ServiceName     string
	ServicePeerID   string
	ServiceProtocol ContractsServiceProtocolType
	DelegatorPeerID string
	DelegatorName   string
	PeerName        pgtype.Text
	ManagerAddress  pgtype.Text
	Iv              uuid.UUID
}

// Copyright © VNG Realisatie 2023
// Licensed under the EUPL
func (q *Queries) ListServices(ctx context.Context, arg *ListServicesParams) ([]*ListServicesRow, error) {
	rows, err := q.db.Query(ctx, listServices, arg.Limit, arg.PaginationStartID, arg.OrderDirection)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListServicesRow{}
	for rows.Next() {
		var i ListServicesRow
		if err := rows.Scan(
			&i.ServiceName,
			&i.ServicePeerID,
			&i.ServiceProtocol,
			&i.DelegatorPeerID,
			&i.DelegatorName,
			&i.PeerName,
			&i.ManagerAddress,
			&i.Iv,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listServicesWithFilter = `-- name: ListServicesWithFilter :many
SELECT
    gp.service_name, gp.service_peer_id, gp.service_protocol, gp.delegator_peer_id, gp.delegator_name, p.name as peer_name, p.manager_address, cc.iv
FROM
    (
        SELECT
            service_name,
            service_peer_id,
            service_protocol,
            content_hash,
            '' as delegator_peer_id,
            '' as delegator_name
        FROM
            contracts.grants_service_publication
        UNION
        SELECT
            service_name,
            service_peer_id,
            service_protocol,
            content_hash,
            delegator_peer_id as delegator_peer_id,
            dp.name as delegator_name
        FROM
            contracts.grants_delegated_service_publication
                join
            peers.peers dp on (grants_delegated_service_publication.delegator_peer_id = dp.id)
    ) as gp
        JOIN
    contracts.valid_contracts as cvc on (cvc.hash = gp.content_hash)
        JOIN
    peers.peers as p on (p.id = gp.service_peer_id)
        JOIN
    contracts.content cc on (cc.hash = gp.content_hash)
WHERE
    (
                $2::text = ''
            OR
                ($3::text = 'asc' AND cc.iv > $2::uuid)
            OR
                ($3::text = 'desc' AND cc.iv < $2::uuid)
        )
  AND
    gp.service_peer_id = $4::text
    OR
     gp.service_name like $5::text
ORDER BY
    CASE
        WHEN $3::text = 'asc' THEN cc.iv END ASC,
    CASE
        WHEN $3::text = 'desc' THEN cc.iv END DESC
LIMIT $1
`

type ListServicesWithFilterParams struct {
	Limit             int32
	PaginationStartID string
	OrderDirection    string
	PeerID            string
	ServiceName       string
}

type ListServicesWithFilterRow struct {
	ServiceName     string
	ServicePeerID   string
	ServiceProtocol ContractsServiceProtocolType
	DelegatorPeerID string
	DelegatorName   string
	PeerName        pgtype.Text
	ManagerAddress  pgtype.Text
	Iv              uuid.UUID
}

func (q *Queries) ListServicesWithFilter(ctx context.Context, arg *ListServicesWithFilterParams) ([]*ListServicesWithFilterRow, error) {
	rows, err := q.db.Query(ctx, listServicesWithFilter,
		arg.Limit,
		arg.PaginationStartID,
		arg.OrderDirection,
		arg.PeerID,
		arg.ServiceName,
	)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListServicesWithFilterRow{}
	for rows.Next() {
		var i ListServicesWithFilterRow
		if err := rows.Scan(
			&i.ServiceName,
			&i.ServicePeerID,
			&i.ServiceProtocol,
			&i.DelegatorPeerID,
			&i.DelegatorName,
			&i.PeerName,
			&i.ManagerAddress,
			&i.Iv,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
